<?php
//ini_set("memory_limit","512M");

include_once('../include/config.php');

// fighting against duplicate stop names and aggregating their data.
$stops = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/stops_list.txt');
$stops = json_decode($stops, $assoc=true);

$duplicates = array();
for ($i = 0; $i < count($stops); $i++)
{
   $dup_run = array();
   for ($j = $i+1; $j < count($stops); $j++)
   {
      if ($stops[$i]['stop_name'] == $stops[$j]['stop_name'])
      {
         if (count($dup_run) == 0)
            $dup_run[] = $stops[$i]['stop_id'];
         $dup_run[] = $stops[$j]['stop_id'];
         $i++; 
      }
      
   }
   
   if (count($dup_run) > 0)
      $duplicates[] = $dup_run;
}

$skip_stops = array();
foreach ($duplicates as $entry)
{
   $compile_to = json_decode(file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $entry[0] . '.txt'), $assoc=true);

   $agg_lines = array();
   foreach ($entry as $stop)
   {
      $file = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $stop . '.txt');
      $lines = json_decode($file, $assoc=true);
      if (!isset($lines['lines']) || $lines['lines'] == null)
         continue;

      $agg_lines = array_merge($agg_lines, $lines['lines']);
   }

   for ($i = 1; $i < count($entry); $i++)
   {
      $skip_stops[] = $entry[$i];
   } 

   $compile_to['lines'] = $agg_lines;
 
   $file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $entry[0] . '.txt', 'w');
   fwrite($file, json_encode($compile_to));
   fclose($file);
}
$routes = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/route_config.txt');
$routes = json_decode($routes, $assoc=true);

$combined_string = '[';

for ($i = 0; $i < count($routes); $i++)
{
   $route_content = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $routes[$i]['route_id'] . '.txt'); 
   $combined_string .= $route_content;
   $combined_string .= ',';
}

$combined_string = substr_replace($combined_string, "", -1);
$combined_string .= ']';

$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/times.txt','w');
fwrite($file, $combined_string);
fclose($file);

$combined_string = '[';
for ($i = 0; $i < count($stops); $i++)
{
   if (in_array($stops[$i]['stop_id'], $skip_stops))
   {
      $stop_content = '{"running":false}';
   }
   else
   {
      $stop_content = file_get_contents($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/' . $stops[$i]['stop_id'] . '.txt');
   }
   
   $combined_string .= $stop_content;
   $combined_string .= ',';
}

$combined_string = substr_replace($combined_string, "", -1);
$combined_string .= ']';

$file = fopen($GLOBALS['CONFIG']['temp_dir'] . '/nextbus/stop_times.txt', 'w');
fwrite($file, $combined_string);
fclose($file);

rename($GLOBALS['CONFIG']['temp_dir'] . '/nextbus', $GLOBALS['CONFIG']['web_dir'] . '/nextbus');
?>
